// a mirror+holder meshed with hex


DefineConstant[ L   = {  1, Min 50, Max 500, Step 1, Name "Lengths/L"   }  ];
DefineConstant[ L_1 = {  1, Min 50, Max 250, Step 1, Name "Lengths/L_1" }  ];
DefineConstant[ H   = {  1, Min 10, Max 100, Step 1, Name "Lengths/H"   }  ];
DefineConstant[ H_1 = {  1, Min  1, Max  20, Step 1, Name "Lengths/H_1" }  ];
DefineConstant[ W   = {  1, Min 25, Max 250, Step 1, Name "Lengths/W"   }  ];

DefineConstant[ nL   = {   1, Min 1, Max 51, Step 1, Name "Mesh/nL"   }  ];
DefineConstant[ nL_1 = {   1, Min 1, Max 51, Step 1, Name "Mesh/nL_1" }  ];
DefineConstant[ nH   = {   1, Min 1, Max 51, Step 1, Name "Mesh/nH"   }  ];
DefineConstant[ nH_1 = {   1, Min 1, Max 51, Step 1, Name "Mesh/nH_1" }  ];
DefineConstant[ nW   = {   1, Min 1, Max 51, Step 1, Name "Mesh/nW"   }  ];

lc = 1; // useless

Point(1) = { 0,   0, 0, lc};
Point(2) = { 0,   0, H, lc};
Point(3) = { L_1, 0, 0, lc};
Point(4) = { L_1, 0, H, lc};
Point(5) = { L_1, 0, H+H_1, lc};
Point(6) = { L+L_1, 0, 0, lc};
Point(7) = { L+L_1, 0, H, lc};
Point(8) = { L+L_1, 0, H+H_1, lc};

Line(1) = {2, 1};
Line(2) = {1, 3};
Line(3) = {4, 2};
Line(4) = {3, 4};
Line(5) = {4, 5};
Line(6) = {3, 6};
Line(7) = {7, 4};
Line(8) = {5, 8};
Line(9) = {6, 7};
Line(10) = {8, 7};

Transfinite Line {6,7,8} = nL Using Progression 1;
Transfinite Line {2,3} = nL_1 Using Progression 1;
Transfinite Line {1,4,9} = nH Using Progression 1;
Transfinite Line {5,10} = nH_1 Using Progression 1;

Line Loop(11) = {2, 4, 3, 1};
Plane Surface(12) = {11};
Transfinite Surface {12};
Recombine Surface {12};

Line Loop(13) = {6,9,7,-4};
Plane Surface(14) = {13};
Transfinite Surface {14};
Recombine Surface {14};

Line Loop(15) = {7, 10, 8, 5};
Plane Surface(16) = {15};
Transfinite Surface {16};
Recombine Surface {16};


Extrude {0, W, 0} 
{
  Surface{12}; Layers{nW}; Recombine;
}

Extrude {0, W, 0} 
{
  Surface{14}; Layers{nW}; Recombine;
}

Extrude {0, W, 0} 
{
  Surface{16}; Layers{nW}; Recombine;
}

// physical entities

Physical Line("Vertical clamped line") = {1};
Physical Line("Horizontal clamped line") = {23};
Physical Surface("Clamped Side") = {37};
Physical Surface("Mirror Side") = {77};
Physical Surface("Contact") = {55};
Physical Volume("Holder") = {1, 2};
Physical Volume("Mirror") = {3};




