/*
 * Copyright 2020 University of Liège
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

// SWIG input file of the 'fdtd' module

%feature("autodoc","1");

%module(docstring=
"'fdtdw' module: projet MP 2017/2018
(c) ULg - A&M",
directors="1",
threads="1"
) fdtdw
%{

#include <string>
#include <sstream>
#include <typeinfo>
#include "fdtd.h"

#include "wProblem.h"

#include "fwkw.h"
#include "tboxw.h"

%}


%include "fwkw.swg"

// ----------- MODULES UTILISES ------------
%import "tboxw.i"

// ----------- FDTD CLASSES ----------------
%include "fdtd.h"

%shared_ptr(fdtd::Problem);

%feature("director:except") {
    if ($error != NULL) {
        std::cout << "[in director:except]\n";
        //throw Swig::DirectorMethodException();
        throw std::runtime_error("Director problem");
    }
}

%include "wProblem.h"
