clc
clear all
[it_fg, res_fg] = read_belos('first_guess_belos_50it.text');
[it_sg, res_sg] = read_belos('second_guess_belos_50it.text');

[it_e1, res_e1] = read_belos('ensemble1_guess_belos_50it.text');
[it_e2, res_e2] = read_belos('ensemble2_guess_belos_50it.text');
[it_e3, res_e3] = read_belos('ensemble3_guess_belos_50it.text');
[it_e4, res_e4] = read_belos('ensemble4_guess_belos_50it.text');
close all


figure
semilogy(it_fg, res_fg,'o','LineWidth',0.5,...
    'MarkerSize',6,...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor','r')
hold on
semilogy(it_sg, res_sg,'o','LineWidth',0.5,...
    'MarkerSize',6,...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor','g')
grid on
box on
set(gca,'fontsize',18)
xlabel('Iteration')
ylabel('(2-Norm Res Vec) / (2-Norm Prec Res0)')


figure

semilogy(it_fg, res_fg,'s','LineWidth',0.5,...
    'MarkerSize',8,...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor','r')
hold on
semilogy(it_sg, res_sg,'s','LineWidth',0.5,...
    'MarkerSize',8,...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor','g')

semilogy(it_e1, res_e1,'o','LineWidth',0.5,...
    'MarkerSize',6,...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor','r')

semilogy(it_e2, res_e2,'o','LineWidth',0.5,...
    'MarkerSize',6,...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor','y')
semilogy(it_e3, res_e3,'o','LineWidth',0.5,...
    'MarkerSize',6,...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor','b')
semilogy(it_e4, res_e4,'o','LineWidth',0.5,...
    'MarkerSize',6,...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor','g')


grid on
box on
set(gca,'fontsize',18)
xlabel('Iteration')
ylabel('(2-Norm Res Vec) / (2-Norm Prec Res0)')

fg_sol = load('solution_first_guess.text');
sg_sol = load('solution_second_guess.text');

e1_sol = load('solution_e1_50it.text');
e2_sol = load('solution_e2_50it.text');
e3_sol = load('solution_e3_50it.text');
e4_sol = load('solution_e4_50it.text');

%%
clc
max(abs(e1_sol(:,1)-fg_sol))
max(abs(e1_sol(:,2)-fg_sol))
max(abs(e2_sol(:,1)-fg_sol))
max(abs(e2_sol(:,2)-sg_sol))
max(abs(e3_sol(:,1)-sg_sol))
max(abs(e3_sol(:,2)-fg_sol))
max(abs(e4_sol(:,1)-sg_sol))
max(abs(e4_sol(:,2)-sg_sol))