/*
 * Copyright 2020 University of Liège
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef WPOINT1_H
#define WPOINT1_H

#include "tbox.h"
#include "wElement.h"

namespace tbox
{

/**
 * @brief Point element (0D)
 * @authors Romain Boman
 */
class TBOX_API Point1 : public Element
{
public:
    Point1(int n, Tag *_ptag, Tag *_etag, std::vector<Tag *> &_parts, std::vector<Node *> &nods);
    virtual ELTYPE type() const override { return ELTYPE::POINT1; }

private:
    static CachePoint1 &getCache(int n);
    virtual Cache &getVCache() const override;
};

} // namespace tbox

#endif //WPOINT1_H
