#!/usr/bin/env python3
# -*- coding: utf-8 -*-
# basic tests on single finite elements

import tbox
import tbox.gmsh as gmsh

def main(**d):

    # 1 triangle
    print('='*80+'\nTesting Tri\n'+'='*80)
    msh = gmsh.MeshLoader('tri1.geo',__file__).execute()    
    
    el = msh.ntags['S1'].elems[0]
    print(el)

    # 1 hex
    print('='*80+'\nTesting Hex\n'+'='*80)
    msh = gmsh.MeshLoader('hex1.geo',__file__).execute()    
    
    el = msh.ntags['Volume'].elems[0]
    print(el)

    # 1 quad
    print('='*80+'\nTesting Quad\n'+'='*80)
    
    msh = gmsh.MeshLoader('quad1.geo',__file__).execute()    
    
    el = msh.ntags['S1'].elems[0]
    print(el)


if __name__ == "__main__":
    main()
